import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

rood = 27
geel = 22
groen = 17

GPIO.setup(rood, GPIO.OUT)
GPIO.setup(geel, GPIO.OUT)
GPIO.setup(groen, GPIO.OUT)

zoemer = 21

GPIO.setup(zoemer, GPIO.OUT)

TRIG = 18
ECHO = 23

GPIO.setup(TRIG,GPIO.OUT)
GPIO.setup(ECHO,GPIO.IN)

def rood_licht():
    GPIO.output(rood, GPIO.HIGH)
    GPIO.output(geel, GPIO.LOW)
    GPIO.output(groen, GPIO.LOW)

def geel_licht():
    GPIO.output(rood, GPIO.LOW)
    GPIO.output(geel, GPIO.HIGH)
    GPIO.output(groen, GPIO.LOW)

def groen_licht():
    GPIO.output(rood, GPIO.LOW)
    GPIO.output(geel, GPIO.LOW)
    GPIO.output(groen, GPIO.HIGH)

def zoem(duration):
    GPIO.output(zoemer, True)
    time.sleep(duration)
    GPIO.output(zoemer, False)

def get_distance():
    GPIO.output(TRIG, True)
    time.sleep(0.00001)
    GPIO.output(TRIG, False)

    start = 0
    end = 0

    start = time.time()
    end = time.time()
    while GPIO.input(ECHO) == False and (end - start) < 1:
        end = time.time()

    start = time.time()
    while GPIO.input(ECHO) == True:
        end = time.time()

    sig_time = end - start
    distance = sig_time / 0.000058

    return distance

try:
    while True:
        distance = get_distance()
        time.sleep(0.05)
        print('Afstand in cm: ' + str(distance))

        if distance >= 30:
            groen_licht()
        elif 30 > distance > 15:
            geel_licht()
            zoem(0.3)
        else:
            rood_licht()
            zoem(0.1)

finally:
    GPIO.cleanup()
