# Picademie.nl - november 2022

import RPi.GPIO as GPIO
import subprocess as sp # tbv schoonmaken scherm (OS commando)
import time

GPIO.setmode(GPIO.BCM) # = GPIO
GPIO.setwarnings(False)

rood = 27  # = GPIO27 = pin13
geel = 22  # = GPIO22 = pin15
groen = 17 # = GPIO17 = pin11

GPIO.setup(rood, GPIO.OUT)
GPIO.setup(geel, GPIO.OUT)
GPIO.setup(groen, GPIO.OUT)

zoemer = 21 # = GPIO21 = pin40

GPIO.setup(zoemer, GPIO.OUT)

TRIG = 18 # = GPIO19 = pin12
ECHO = 23 # = GPIO23 = pin16

GPIO.setup(TRIG,GPIO.OUT)
GPIO.setup(ECHO,GPIO.IN)

def rood_licht():
    GPIO.output(rood, GPIO.HIGH)
    GPIO.output(geel, GPIO.LOW)
    GPIO.output(groen, GPIO.LOW)

def geel_licht():
    GPIO.output(rood, GPIO.LOW)
    GPIO.output(geel, GPIO.HIGH)
    GPIO.output(groen, GPIO.LOW)

def groen_licht():
    GPIO.output(rood, GPIO.LOW)
    GPIO.output(geel, GPIO.LOW)
    GPIO.output(groen, GPIO.HIGH)

def zoem(duration):
    GPIO.output(zoemer, True)
    time.sleep(duration)
    GPIO.output(zoemer, False)

def get_distance():
    GPIO.output(TRIG, True)
    time.sleep(0.00001)
    GPIO.output(TRIG, False)

    start = 0
    end = 0

    start = time.time()
    end = time.time()

    while GPIO.input(ECHO) == False and (end - start) < 1:
        end = time.time()

    start = time.time()

    while GPIO.input(ECHO) == True:
        end = time.time()

    sig_time = end - start
    distance = sig_time / 0.000058

    return distance

while True:
    distance = get_distance()
    distance = round(distance, 2)
    #distance = int(distance) # Vind je de output onrustig? Verwijder dan de # voor deze regel

    time.sleep(0.05)

    # Clear screen = OS commando
    tmp = sp.call('clear',shell=True)

    print ("\n\033[1;32mParkeerhulp")
    print ("===========\n")


    print("\033[1;33mDe gemeten afstand is " + str(distance) + " cm\033[1;m")

    print ("\n\nMet CTRL-c stop je het programma")


    # vergelijkingen om de juiste functie aan te roepen
    if distance >= 30:
        groen_licht()
    elif 30 > distance > 15:
        geel_licht()
        zoem(0.3)
    else:
        rood_licht()
        zoem(0.1)

